# coding: utf-8

"""
    Ethos

    API for Ethos AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field, validator

class Activity(BaseModel):
    """
    Activity
    """
    object: Optional[Any] = Field(...)
    id: Optional[Any] = Field(...)
    name: Optional[Any] = Field(...)
    state: Optional[Any] = Field(...)
    created_at: Optional[Any] = Field(...)
    index: Optional[Any] = Field(...)
    phase: Optional[Any] = Field(...)
    tasks: Optional[Any] = Field(...)
    __properties = ["object", "id", "name", "state", "created_at", "index", "phase", "tasks"]

    @validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('initialized', 'in_progress', 'done', 'failed', 'skipped'):
            raise ValueError("must be one of enum values ('initialized', 'in_progress', 'done', 'failed', 'skipped')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Activity:
        """Create an instance of Activity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if object (nullable) is None
        # and __fields_set__ contains the field
        if self.object is None and "object" in self.__fields_set__:
            _dict['object'] = None

        # set to None if id (nullable) is None
        # and __fields_set__ contains the field
        if self.id is None and "id" in self.__fields_set__:
            _dict['id'] = None

        # set to None if name (nullable) is None
        # and __fields_set__ contains the field
        if self.name is None and "name" in self.__fields_set__:
            _dict['name'] = None

        # set to None if state (nullable) is None
        # and __fields_set__ contains the field
        if self.state is None and "state" in self.__fields_set__:
            _dict['state'] = None

        # set to None if created_at (nullable) is None
        # and __fields_set__ contains the field
        if self.created_at is None and "created_at" in self.__fields_set__:
            _dict['created_at'] = None

        # set to None if index (nullable) is None
        # and __fields_set__ contains the field
        if self.index is None and "index" in self.__fields_set__:
            _dict['index'] = None

        # set to None if phase (nullable) is None
        # and __fields_set__ contains the field
        if self.phase is None and "phase" in self.__fields_set__:
            _dict['phase'] = None

        # set to None if tasks (nullable) is None
        # and __fields_set__ contains the field
        if self.tasks is None and "tasks" in self.__fields_set__:
            _dict['tasks'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Activity:
        """Create an instance of Activity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Activity.parse_obj(obj)

        _obj = Activity.parse_obj({
            "object": obj.get("object"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "state": obj.get("state"),
            "created_at": obj.get("created_at"),
            "index": obj.get("index"),
            "phase": obj.get("phase"),
            "tasks": obj.get("tasks")
        })
        return _obj


